unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, EditBtn, StdCtrls,
  Buttons, ExtDlgs, ExtCtrls, PrintersDlgs;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    PrintDialog1: TPrintDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLIntf, Math, Printers, OSPrinters;

{ TForm1 }

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  with OpenPictureDialog1 do
  begin
    if FileName <> '' then
      InitialDir := ExtractFileDir(FileName);
    FileName := '';
    if Execute then
      Image1.Picture.LoadFromFile(FileName);
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
const
  PAGE_MARGIN = 10; //mm
var
  R: TRect;
  horMargin, vertMargin: Integer;
  wPic, hPic: Integer;
  wPage, hPage: Integer;
  factor: Double;
begin
  if (Image1.Picture.Width = 0) or (Image1.Picture.Height = 0) then
    exit;

  if PrintDialog1.Execute then
  begin
    Printer.BeginDoc;
    try
      horMargin := Round(PAGE_MARGIN/25.4 * Printer.XDPI);
      vertMargin := Round(PAGE_MARGIN/25.4 * Printer.YDPI);
      wPage := Printer.PageWidth - 2*horMargin;
      hPage := Printer.PageHeight - 2*vertMargin;
      wPic := Image1.Picture.Width;
      hPic := Image1.Picture.Height;
      factor := Min(wPage/wPic, hPage/hPic);
      R := Rect(0, 0, round(wPic*factor), round(hPic*factor));
      OffsetRect(R, horMargin, vertMargin);
      Printer.Canvas.StretchDraw(R, Image1.Picture.Graphic);
    finally
      Printer.EndDoc;
    end;
  end;
end;

end.

